# PMIDAS with CSD estimated with CCE and heterogeneous fixed effects
CCE <- function(Data, nowcast_date){
  # get the main data matrices
  # 
  hicp_lag <- ifelse(nowcast_date < 18, 2,1)
  
  Y <- Data$Y
  X1 <- Data[[2]] #MF regressor
  Y1 <- lag.xts(Y, k = hicp_lag, na.pad = F)
  
  
  Y <- window(Y, start = start(Y1))
  
  # Proceed with estimation
  Tot <- nrow(Y)
  N <- ncol(Y)
  ys <- rowMeans(Y1) # means of the lagged matrix
  xs1 <- rowMeans(X1)  # means of the lagged matrix
  e_f <- rep(0,N)
  
  tin <- Tot - 1 #Evaluation sample
  
  lags <- floor(((Tot)^(1/3))) + 2
  
  yslags <- matrix(0,nrow = Tot - lags,ncol = lags)
  xslags11 <- matrix(0,nrow = Tot - lags,ncol = lags)
  xslags12 = matrix(0, nrow = (Tot - lags),ncol = lags)
  xslags13 = matrix(0, nrow = (Tot - lags),ncol = lags)
  xslags14 = matrix(0, nrow = (Tot - lags),ncol = lags)
  
  
  lfindex <- index(Y) #the low freq time index
  hfindex <- index(X1)
  nlags = 4
  
  ndate <- lapply(lfindex, nearestdate, hfindex,nlags, nowcast_date)
  ndate <- do.call("rbind", ndate)
  
  head(ndate)
  
  X1 <- coredata(X1)
  Y_1 <- coredata(Y1)
  Y <- coredata(Y)
  
  
  for (s in 1:lags) {
    start.pt <- lags - s + 1
    end.pt <- Tot - s
    
    yslags[,s] <- ys[start.pt:end.pt]
    xslags11[,s] <- xs1[ndate[(start.pt:end.pt),1]]
    xslags12[,s] <- xs1[ndate[(start.pt:end.pt),2]]
    xslags13[,s] <- xs1[ndate[(start.pt:end.pt),3]]
    xslags14[,s] <- xs1[ndate[(start.pt:end.pt),4]]
  }
  
  
  pred <- rep(NA, N)
  for (i in 1:N) {
    
    st <- lags + 1
    en <- tin
    y <- Y[st:en,i]
    # %matrix
    X <- cbind.data.frame(Y1[(st):(en),i],
               X1[ndate[((lags + 1):tin),1],i],
               X1[ndate[(lags + 1):tin,2],i],
               X1[ndate[(lags + 1):tin,3],i],
               X1[ndate[(lags + 1):tin,4],i],
               
               
               ys[(st):(en)],
               xs1[ndate[((lags + 1):tin),1]],
               xs1[ndate[((lags + 1):tin),2]],
               xs1[ndate[((lags + 1):tin),3]],
               xs1[ndate[((lags + 1):tin),4]],
               
               yslags[1:(tin - lags),],
               
               xslags11[1:(tin - lags),], 
               xslags12[1:(tin - lags),], 
               xslags13[(1:(tin - lags)),],
               xslags14[(1:(tin - lags)),]
    )
    lm.mod <- lm(y~as.matrix(X), singular.ok = F)
    b <- lm.mod$coefficients
    
    X_p <- c(1,Y1[Tot,i],
             
             X1[ndate[Tot,1],i],
             X1[ndate[Tot,2],i],
             X1[ndate[Tot,3],i],
             X1[ndate[Tot,4],i],
             
             ys[Tot], 
             xs1[ndate[Tot,1]], 
             xs1[ndate[Tot,2]], 
             xs1[ndate[Tot,3]],
             xs1[ndate[Tot,4]],
             
             
             yslags[Tot - lags,],
             xslags11[Tot - lags,], 
             xslags12[Tot - lags,], 
             xslags13[Tot - lags,],
             xslags14[Tot - lags,])
    
    
    pred[i] <- X_p %*% b
  }
  pred
}

