# PMIDAS with CSD estimated with CCE and pooled fixed effects
pooled_cce  <-  function(Data, nowcast_date) {
  pred <- NULL
  
  hicp_lag <- ifelse(nowcast_date < 18, 2,1)
  
  Y <- Data$Y
  X1 <- Data[[2]] #MF regressor
  Y1 <- lag.xts(Y, k = hicp_lag, na.pad = F)
  
  
  Y <- window(Y, start = start(Y1))
  
  Tot <- nrow(Y)
  N <- ncol(Y)
  
  lags <- floor(((Tot)^(1/3))) 
  
  tin <- Tot - 1
  
  
  
  D1 <- kronecker(diag(N), rep(1,tin - lags))
  D1_pred <- diag(N)
  
  
  lfindex <- index(Y) #the low freq time index
  hfindex <- index(X1)
  nlags = 4
  
  ndate <- lapply(lfindex, nearestdate, hfindex,nlags, nowcast_date)
  ndate <- do.call("rbind", ndate)

  head(ndate)
  which(ndate < 0, arr.ind = T)
  
  X1 <- coredata(X1)
  Y_1 <- coredata(Y1)
  Y <- coredata(Y)
  
  yin <- c(Y[(lags + 1):tin,])
  D2X1 <- cbind(c(X1[ndate[((lags + 1):tin),1],]),
                c(X1[ndate[(lags + 1):tin,2],]),
                c(X1[ndate[(lags + 1):tin,3],]),
                c(X1[ndate[(lags + 1):tin,4],]))

  D2Y1 <- c((coredata(Y_1)[((lags + 1):(tin)),]))
  D2 <- cbind(D2Y1, D2X1)
  
  D2_pred <- cbind((Y_1[Tot,]),
                   X1[ndate[Tot,1],],
                   X1[ndate[Tot,2],],
                   X1[ndate[Tot,3],],
                   X1[ndate[Tot,4],])
  
  
  
  ys <- rowMeans(Y_1)
  
  X11 <- rowMeans(X1)
  
  
  yslags <- matrix(0,nrow = Tot - lags,ncol = lags)
  X1lags11 <- matrix(0,nrow = Tot - lags,ncol = lags )
  X1lags12 <- matrix(0, nrow = (Tot - lags),ncol = lags)
  X1lags13 <- matrix(0, nrow = (Tot - lags),ncol = lags )
  X1lags14 <- matrix(0, nrow = (Tot - lags),ncol = lags )
  
  
  for (s in 1:lags) {
    start.pt <- lags - s + 1
    end.pt <- Tot - s
    
    
    yslags[,s] <- ys[(start.pt:end.pt)]

    X1lags11[,s] <- X11[ndate[(start.pt:end.pt),1]]
    X1lags12[,s] <- X11[ndate[(start.pt:end.pt),2]]
    X1lags13[,s] <- X11[ndate[(start.pt:end.pt),3]]
    X1lags14[,s] <- X11[ndate[(start.pt:end.pt),4]]
  }
  
  
  r1 <- cbind(ys[(lags + 1):(tin)],
              X11[ndate[((lags + 1):tin),1]],
              X11[ndate[((lags + 1):tin),2]],
              X11[ndate[((lags + 1):tin),3]],
              X11[ndate[((lags + 1):tin),4]]
  )
  r2 <- cbind(yslags[1:(tin - lags),],
              X1lags11[1:(tin - lags),], 
              X1lags12[1:(tin - lags),], 
              X1lags13[1:(tin - lags),],
              X1lags14[1:(tin - lags),])
  
  which(is.na(r2), arr.ind = T)
  z <- cbind(r1,r2)
  
  
  D3 <- do.call(rbind, replicate(N, z, simplify = FALSE))
  
  r1_pred <- c(ys[(Tot)],
               X11[ndate[Tot,1]], 
               X11[ndate[Tot,2]], 
               X11[ndate[Tot,3]],
               X11[ndate[Tot,4]])
  
  
  r2_pred <- c(yslags[(Tot - lags),],
               X1lags11[Tot - lags,], 
               X1lags12[Tot - lags,], 
               X1lags13[Tot - lags,],
               X1lags14[Tot - lags,])
  
  z_pred <- c(r1_pred,r2_pred)
  D3_pred <- do.call(rbind, replicate(N, z_pred, simplify = FALSE))
  #Heterogenous intercepts
  Dmat <- cbind(D1,D2,D3)
  D_pred <- cbind(D1_pred, D2_pred, D3_pred)
  
  cce.stacked <- lm(formula = yin~Dmat-1, singular.ok = F)
  coefs <- cce.stacked$coefficients
  if (sum(is.na(coefs))) {
    stop("NA CoeffiX1ents")
  }
  pred <- D_pred  %*% coefs
  pred
}

